import { useMutation, useQueryClient } from '@tanstack/react-query';
import { useParams } from 'react-router-dom';

import { ReposService } from '@/client/services/ReposService';

export function useDeleteProtectionRule() {
  const { workspaceName = '', repoName = '' } = useParams();
  const qc = useQueryClient();

  return useMutation({
    mutationFn: (ruleId: string) =>
      ReposService.repoDeleteProtectionRule({ workspaceName, repoName, ruleId }),
    onSuccess: () => {
      qc.invalidateQueries({
        queryKey: ['repo', workspaceName, repoName, 'protection-rules'],
      });
    },
  });
}
